/* Arduino Steering Wheel controller */

#include <Joystick.h>
#include<Wire.h>

Joystick_ Joystick;
int Xaxis = 0;
int Yaxis = 0;

const int MPU_addr=0x68; 
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;
int minVal=265; 
int maxVal=402;
double x; 
double y; 
double z;

const bool initAutoSendState = true;    //Constantly sends joystick data to computer

void setup(){
  Wire.begin(); 
  Wire.beginTransmission(MPU_addr); 
  Wire.write(0x6B); Wire.write(0); 
  Wire.endTransmission(true); 
  Joystick.begin();     //Begin joystick library

  pinMode(0,INPUT_PULLUP);    //Define all buttons
  pinMode(1,INPUT_PULLUP);
  pinMode(6,INPUT_PULLUP);
  pinMode(7,INPUT_PULLUP);
  pinMode(4,INPUT_PULLUP);
  pinMode(5,INPUT_PULLUP);
}

void loop(){

  Wire.beginTransmission(MPU_addr); 
  Wire.write(0x3B); 
  Wire.endTransmission(false); 
  Wire.requestFrom(MPU_addr,14,true); 
  
  AcX=Wire.read()<<8|Wire.read(); 
  AcY=Wire.read()<<8|Wire.read(); 
  AcZ=Wire.read()<<8|Wire.read(); 
  
  int xAng = map(AcX,minVal,maxVal,-90,90); 
  int yAng = map(AcY,minVal,maxVal,-90,90); 
  int zAng = map(AcZ,minVal,maxVal,-90,90);

  x= RAD_TO_DEG * (atan2(-yAng, -zAng)+PI);     //Calculating angle
  y= RAD_TO_DEG * (atan2(-xAng, -zAng)+PI); 
  z= RAD_TO_DEG * (atan2(-yAng, -xAng)+PI);

  Yaxis = analogRead(A1);   //Setting joystick Y axis as computer Z axis
  Yaxis = map(Yaxis,1023,0,127,0);
  Joystick.setZAxis(Yaxis);

  z = map(z,0,140,0,280);   //Setting Gyroscope angle z as X axis
  Joystick.setXAxis(z);

  if (digitalRead(0)==LOW){     //If button pressed...
    Joystick.pressButton(0);    //Joystick built-in button
  }
  else{
    Joystick.releaseButton(0);
  }

  if (digitalRead(1)==LOW){     //If button pressed...
    Joystick.pressButton(7);    //Center button
  }
  else{
    Joystick.releaseButton(7);
  }

  if (digitalRead(6)==LOW){     //If button pressed...
    Joystick.pressButton(1);    //Left button
  }
  else{
    Joystick.releaseButton(1);
  }

  if (digitalRead(7)==LOW){     //If button pressed...
    Joystick.pressButton(2);    //Right button
  }
  else{
    Joystick.releaseButton(2);
  }

  if (digitalRead(4)==LOW){     //If button pressed...
    Joystick.pressButton(3);    //Up button
  }
  else{
    Joystick.releaseButton(3);
  }

  if (digitalRead(5)==LOW){     //If button pressed...
    Joystick.pressButton(4);    //Down button
  }
  else{
    Joystick.releaseButton(4);
  }

}
